﻿/// @file parsewav_dft.h
///
/// @author Sasaji
/// @date   2017.12.01
///

#ifndef _PARSEWAV_DFT_H_
#define _PARSEWAV_DFT_H_

#include "common.h"
#include "errorinfo.h"
#include "parsewav_buffer.h"

/// @brief フーリエ変換クラス
class PARSEWAV_DFT
{
private:
	double samples;		// 1200/2400Hzのサンプル数
	double h[2][50];	// 0:1200Hz 1:2400Hz

	Buf_t<int> freq_data[2];
	int a_max;
	int a_min;

public:
	PARSEWAV_DFT();
	~PARSEWAV_DFT();

	void Init(double samples, int type);
	int  Calcrate(Buf_t<uint8_t> *w_data, Buf_t<uint8_t> *wc_data);

	int GetAmpMax() { return a_max; }
	int GetAmpMin() { return a_min; }
};

#endif
