﻿/// @file parsewav_param.cpp
///
/// @brief waveデータ <-> 搬送波データ <-> シリアルデータ　変換用パラメータ
///
/// @author Sasaji
/// @date   2011.7.1
///

#include "parsewav_param.h"

PARSEWAV_PARAM::PARSEWAV_PARAM()
{
	// パラメータ初期化
	fsk_speed = 0;

	for(int i=0; i<3; i++) {
		freq[i] = (1200 << i);
	}
	range[0] = 25;
	range[1] = 50;
	reverse = 0;

	half_wave = 1;
	correct = 0;
	correct_type = 0;

	baud = 0;
	auto_baud = 1;
	word_select = 0x04;

	debug_log = false;

	sample_rate = 3;	// 48000
	sample_bits = 0;	// 8bit

	file_split = 0;
	del_mhead = 0;
}

PARSEWAV_PARAM::~PARSEWAV_PARAM()
{
}

void PARSEWAV_PARAM::SetFrequency(int magnify)
{
	fsk_speed = (magnify - 1);
//	freq1200 = 1200 * magnify;
//	freq2400 = 2400 * magnify;
}

int PARSEWAV_PARAM::GetBaseFreq(void)
{
	return 1200 * (fsk_speed + 1);
}
