﻿/// @file parsewav_param.h
///
/// @brief waveデータ <-> 搬送波データ <-> シリアルデータ　変換用パラメータ
///
/// @author Sasaji
/// @date   2011.7.1
///
#ifndef _PARSEWAV_PARAM_H_
#define _PARSEWAV_PARAM_H_

/// ダイアログ用パラメータ
class PARSEWAV_PARAM
{
private:
	int fsk_speed;	///< 0:standard(1200 and 2400Hz) 1:double speed(2400 and 4800Hz)
	int freq[3];	///< 0:1200 1:2400 2:4800 (Hz)
	int range[2];	///< 0:long 1:short
	int reverse;
	int baud;		///< 0:600band 1:1200band 2:2400baud 3:300baud
	int auto_baud;
	int word_select;
	int half_wave;
	int correct;
	int correct_type;
	int debug_log;
	int sample_bits;
	int sample_rate;
	int file_split;
	int del_mhead;
	int chg_gap_size;

public:
	PARSEWAV_PARAM();
	~PARSEWAV_PARAM();

	void SetSampleRate(int value) { sample_rate = value; }
	void SetSampleBits(int value) {	sample_bits = value; }
	void SetBaud(int value)		{ baud = value; }
	void SetAutoBaud(int value) { auto_baud = value; }
	void SetReverseWave(int value) { reverse = (value ? 1 : 0); }
	void SetHalfWave(int value) { half_wave = (value ? 1 : 0); }
	void SetCorrectWave(int value) { correct = (value ? 1 : 0); }
	void SetCorrectType(int value) { correct_type = value; }
	void SetFskSpeed(int value) { fsk_speed = value; }
	void SetFreq(int num, int value) { freq[num] = value; }
//	void SetFreq1200(int value) { freq[0] = value; }
//	void SetFreq2400(int value) { freq[1] = value; }
	void SetFrequency(int magnify);
	void SetRange(int num, int value) { range[num] = value; }
//	void SetRange1200(int value) { range[0] = value; }
//	void SetRange2400(int value) { range[1] = value; }
	void SetWordSelect(int value) { word_select = value; }
	void SetFileSplit(int value) { file_split = value; }
	void SetDeleteMHead(int value) { del_mhead = value; }
	void SetChangeGapSize(int value) { chg_gap_size = value; }
	void SetDebugMode(int value) { debug_log = value; }

	int GetSampleRate(void) { return sample_rate; }
	int GetSampleBits(void) { return sample_bits; }
	int GetBaud(void)		{ return baud; }
	int	GetAutoBaud(void)   { return auto_baud; }
	int GetReverseWave(void) { return reverse; }
	int GetHalfWave(void)	{ return half_wave; }
	int GetCorrectWave(void) { return correct; }
	int GetCorrectType(void) { return correct_type; }
	int GetFskSpeed(void) { return fsk_speed; }
	int GetFreq(int num) { return freq[num]; }
//	int GetFreq1200(void) { return freq[0]; }
//	int GetFreq2400(void) { return freq[1]; }
	int	GetRange(int num) { return range[num]; }
//	int	GetRange1200(void) { return range[0]; }
//	int	GetRange2400(void) { return range[1]; }
	int	GetWordSelect(void) { return word_select; }
	int GetFileSplit(void) { return file_split; }
	int GetDeleteMHead(void) { return del_mhead; }
	int GetChangeGapSize(void) { return chg_gap_size; }
	int GetDebugMode(void) { return debug_log; }
	int GetBaseFreq(void);
};

#endif
