﻿/// @file parsewav_util.h
///
/// @author Sasaji
/// @date   2011.12.01
///

#ifndef _PARSEWAV_UTIL_H_
#define _PARSEWAV_UTIL_H_

#include "errorinfo.h"
#include "parsewav_format.h"

/// @brief WAVファイルを扱うクラス
class PARSEWAV_UTIL
{
private:
	int remain_buf[100];
	int remain_buf_len;
	int divide;
	int surplus;

	size_t out_sample_buffer(int16_t *in_buf, size_t in_len, int in_blk_size, int out_blk_size, FILE *fp);

public:
	PARSEWAV_UTIL();
	~PARSEWAV_UTIL();

	void   InitConvSampleData();
	void   OutConvSampleData(void *in_buf, int in_rate, int in_blk_size, size_t in_len
						, int outrate, int out_blk_size, FILE *fp);
	size_t ReadWavData(FILE *fin, wav_fmt_chank_t *in_fmt, size_t in_len, uint8_t *outbuf, uint32_t outrate, int outbits, size_t outlen);

	static PwErrCode CheckWavFormat(FILE *fp, wav_header_t *head, wav_fmt_chank_t *fmt, wav_data_chank_t *data, size_t *data_len = NULL);
	static PwErrCode CheckWavFormat(FILE *fp, PARSEWAV_FORMAT &format, size_t *data_len = NULL);
};

#endif
